DAT  fileName byte "RgbLedDemo110729f", 0
CON{{ 

  Modified from RedGreenBlue110729f

  ---- Private Notes -------
  110728a Move LED control to child object (this object).
  29c the flashing doesn't seem to work correctly.
  29d works a little.
  29e only flashes once.
  29f works okay.
  Changed file name from RedGreenBlue110729f
  to RgbLedDemo110729f
  110729f Change to demo program of child
  object.
  
  ---- Public Notes -------
  
  This is a demo of RgbLed110729f.
  This demo shows examples of using
  the object to blink a rgb LED.

  Use to drive a common cathode RGB LED.
  
  The color of the LED can be change
  both while using the "solid" method
  or while blinking.
  See the child object for discriptions
  of the various methods.
  
}} 
CON

  _clkmode = xtal1 + pll16x                           
  _xinfreq = 5_000_000
    
CON

  _LedBluePin = 20
  _LedRedPin = 19
  _LedGreenPin = 18
                         
VAR

  long commandLocation
 
  byte red, green, blue 
  
  
OBJ   

  Debug : "FullDuplexSerial"    
  Led : "RgbLed110729f"
    
PUB MainDemo | localIndex[3]
''  Remove this method to use as a child object only.

  Debug.start(31, 30, 0, 57600)
  {
  repeat while debug.rxcheck == -1
    Debug.str(String(13, "Press any key to start."))
    waitcnt(clkfreq / 10 + cnt)
  }
  waitcnt(clkfreq * 2 + cnt)
  Debug.str(String(13, "fileName = "))
  Debug.dec(fileName)
  
  commandLocation := Led.Init(_LedRedPin, _LedGreenPin, _LedBluePin)
  Debug.str(String(13, "commandLocation = "))
  Debug.dec(commandLocation)

  localIndex[0] := Led.Start
  Debug.str(String(13, "Start returned = "))
  Debug.dec(localIndex[0])
  

  localIndex[0] := 0
  localIndex[1] := 0
  localIndex[2] := 0
  repeat
    repeat 2
      Led.FlashLed($CF, $7F, 0, 1000, 200) ' command LED to flash yellow 200 times
      waitcnt(clkfreq * 4 + cnt)           ' let flash four times
      Led.Off                              ' turn LED off
      waitcnt(clkfreq * 4 + cnt)
      Led.SolidLed(0, $7F, 0, 16000)     ' solid green 16 minutes
      waitcnt(clkfreq * 2 + cnt)         ' on for two seconds
      Led.Off                            ' turn off early

    repeat 2
      Led.FlashLed($CF, $7F, 0, 1000, 8) ' flash yellow eight times
      waitcnt(clkfreq * 8 + cnt)
      Led.FlashLed($7F, 0, 0, 1000, 8)
      waitcnt(clkfreq * 8 + cnt)
      Led.FlashLed(0, $7F, 0, 1000, 8)
      waitcnt(clkfreq * 8 + cnt)
      Led.FlashLed(0, 0, $7F, 1000, 8)
      waitcnt(clkfreq * 8 + cnt)
     
            
    repeat 1   
      repeat localIndex[0] from 0 to $F0 step $30
        repeat localIndex[1] from 0 to $F0 step $30 
          repeat localIndex[2] from 0 to $F0 step $30      
            Led.FlashLed(localIndex[0], localIndex[1], localIndex[2], 500, 2) ' flash twice then change color
            waitcnt(clkfreq + cnt)
    repeat 2
      Led.SolidLed($7F, $7F, $7F, 2000) ' solid white for two seconds
      waitcnt(clkfreq * 2 + cnt)
      Led.FlashLed($7F, $7F, $7F, 500, 10)
      waitcnt(clkfreq * 5 + cnt)
      Led.SolidLed($0, $7F, $0, 2000)
      waitcnt(clkfreq * 2 + cnt)
      Led.FlashLed($7F, $0, $0, 1000, 5)
      waitcnt(clkfreq * 5 + cnt)
      Led.SolidLed($0, $0, $7F, 2000)
      waitcnt(clkfreq * 2 + cnt)
      Led.FlashLed($7F, $7F, $0, 500, 10)
      waitcnt(clkfreq * 5 + cnt)
      Led.SolidLed($7F, $0, $0, 2000)
      waitcnt(clkfreq * 2 + cnt)
      Led.FlashLed($0, $7F, $7F, 250, 20)
      waitcnt(clkfreq * 5 + cnt)
      Led.SolidLed($F0, $90, $0, 2000)
      waitcnt(clkfreq * 2 + cnt)       
    Led.SolidLed(0, 0, 0, 0)
    repeat 1   
      repeat localIndex[0] from 0 to $F0 step $30
        repeat localIndex[1] from 0 to $F0 step $30
          repeat localIndex[2] from 0 to $F0 step $30     
            Led.ChangeColor(localIndex[0], localIndex[1], localIndex[2])
            waitcnt(clkfreq / 10 + cnt)
      repeat localIndex[0] from 0 to $F0 step $30
        repeat localIndex[1] from 0 to $F0 step $30
          repeat localIndex[2] from 0 to $F0 step $30     
            Led.ChangeColor(localIndex[0], localIndex[2], localIndex[1])
            waitcnt(clkfreq / 10 + cnt)
      repeat localIndex[0] from 0 to $F0 step $30
        repeat localIndex[1] from 0 to $F0 step $30
          repeat localIndex[2] from 0 to $F0 step $30     
            Led.ChangeColor(localIndex[1], localIndex[0], localIndex[2])
            waitcnt(clkfreq / 10 + cnt)
      repeat localIndex[0] from 0 to $F0 step $30
        repeat localIndex[1] from 0 to $F0 step $30
          repeat localIndex[2] from 0 to $F0 step $30     
            Led.ChangeColor(localIndex[2], localIndex[0], localIndex[1])
            waitcnt(clkfreq / 10 + cnt)
      repeat localIndex[0] from 0 to $F0 step $30
        repeat localIndex[1] from 0 to $F0 step $30
          repeat localIndex[2] from 0 to $F0 step $30     
            Led.ChangeColor(localIndex[1], localIndex[2], localIndex[0])
            waitcnt(clkfreq / 10 + cnt)
      repeat localIndex[0] from 0 to $F0 step $30
        repeat localIndex[1] from 0 to $F0 step $30
          repeat localIndex[2] from 0 to $F0 step $30     
            Led.ChangeColor(localIndex[2], localIndex[1], localIndex[0])
            waitcnt(clkfreq / 10 + cnt)
     
    Led.SolidLed(255, 255, 255, 4000)
    waitcnt(clkfreq * 4 + cnt)
    Led.SolidLed(255, 0, 0, 4000)
    waitcnt(clkfreq * 4 + cnt)
    Led.SolidLed(0, 255, 0, 4000)
    waitcnt(clkfreq * 4 + cnt)
    Led.SolidLed(0, 0, 255, 4000)
    waitcnt(clkfreq * 4 + cnt)
                        